// ========================================================
//
// 3402_R_Junction_React
// CBP 12-02-22
// FBO 20-08-21
// CBP 21-08-21 Now uses library CBPFBO_StepperA
//
// ========================================================

#include <CBPFBO_StepperA.h>
#define DEBUG false  

// Here's how to define some states for a FSM if you like
#define STATE_EXPLORE 1
#define STATE_LEFT_TURN 2
#define STATE_RIGHT_TURN 3
#define STATE_ABOUT_FACE 4
int state;

// This is the main Pixy object 
Pixy2 pixy;

float error;
float gain;

uint8_t x0;
uint8_t y0;

int junctionResult;

void setup(){
  Serial.begin(9600);                       
  gain = 1.0;  

  state = STATE_EXPLORE;

  pixy.init();
  // Change to line tracking program
  pixy.changeProg("line");
  pixy.setLamp(1, 0);
  
}

void loop() {

  pixy.line.getAllFeatures();

  x0 = pixy.line.vectors[0].m_x0;
  y0 = pixy.line.vectors[0].m_y0;

  
 
                        
}

int junctionSearch(Pixy2 pixy) {

  int junctionNumber = 0;
  int angleDetected;
  
  int16_t angs[3];
    for(int i = 0; i < 3; i++) {
       angs[i] = pixy.line.intersections[0].m_intLines[i].m_angle;
       Serial.print("angs[");
       Serial.print(i);
       Serial.print("] = ");
       Serial.println(angs[i]);
    }

    junctionNumber = detectCorners(angs);

  return junctionNumber;
}

float getErrorX() {
  float error;
  error = x0 - 40;
  error = -error / 40;
  return error; 
}
