// ========================================================
//
// 3402_R_Junction_Test
// CBP 12-02-22
// FBO 20-08-21
// CBP 21-08-21 Now uses library CBPFBO_StepperA
//
// ========================================================

#include <CBPFBO_StepperA.h>
#define DEBUG false  

Pixy2 pixy;

// Pixycam variables -------
uint8_t x0;
uint8_t y0;
int16_t angs[3];

int junctionResult;

void setup(){
  Serial.begin(9600);                       
  pixy.init();
  // Change to line tracking program
  pixy.changeProg("line");
  pixy.setLamp(1, 0);
  
}

void loop() {

  pixy.line.getAllFeatures();

  x0 = pixy.line.vectors[0].m_x0;
  y0 = pixy.line.vectors[0].m_y0;

  for(int i = 0; i < 4; i++) {
     angs[i] = pixy.line.intersections[0].m_intLines[i].m_angle;
     cprintf("Angle[%d] = %d\n",i,angs[i]);
  }

  cprintf("---\n");
  delay(1000);
                  
}
